module GI.Gtk.Objects.TextView where

import Data.GI.Base.ShortPrelude

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

newtype TextView = TextView (ForeignPtr TextView)
instance GObject TextView where
class GObject o => TextViewK o
instance (GObject o, IsDescendantOf TextView o) => TextViewK o
data TextViewAcceptsTabPropertyInfo
data TextViewBottomMarginPropertyInfo
data TextViewBufferPropertyInfo
data TextViewCursorVisiblePropertyInfo
data TextViewEditablePropertyInfo
data TextViewImModulePropertyInfo
data TextViewIndentPropertyInfo
data TextViewInputHintsPropertyInfo
data TextViewInputPurposePropertyInfo
data TextViewJustificationPropertyInfo
data TextViewLeftMarginPropertyInfo
data TextViewMonospacePropertyInfo
data TextViewOverwritePropertyInfo
data TextViewPixelsAboveLinesPropertyInfo
data TextViewPixelsBelowLinesPropertyInfo
data TextViewPixelsInsideWrapPropertyInfo
data TextViewPopulateAllPropertyInfo
data TextViewRightMarginPropertyInfo
data TextViewTabsPropertyInfo
data TextViewTopMarginPropertyInfo
data TextViewWrapModePropertyInfo
data TextViewBackspaceSignalInfo
data TextViewCopyClipboardSignalInfo
data TextViewCutClipboardSignalInfo
data TextViewDeleteFromCursorSignalInfo
data TextViewExtendSelectionSignalInfo
data TextViewInsertAtCursorSignalInfo
data TextViewMoveCursorSignalInfo
data TextViewMoveViewportSignalInfo
data TextViewPasteClipboardSignalInfo
data TextViewPopulatePopupSignalInfo
data TextViewPreeditChangedSignalInfo
data TextViewSelectAllSignalInfo
data TextViewSetAnchorSignalInfo
data TextViewToggleCursorVisibleSignalInfo
data TextViewToggleOverwriteSignalInfo
data TextViewAddChildAtAnchorMethodInfo
data TextViewAddChildInWindowMethodInfo
data TextViewBackwardDisplayLineMethodInfo
data TextViewBackwardDisplayLineStartMethodInfo
data TextViewBufferToWindowCoordsMethodInfo
data TextViewForwardDisplayLineMethodInfo
data TextViewForwardDisplayLineEndMethodInfo
data TextViewGetAcceptsTabMethodInfo
data TextViewGetBorderWindowSizeMethodInfo
data TextViewGetBottomMarginMethodInfo
data TextViewGetBufferMethodInfo
data TextViewGetCursorLocationsMethodInfo
data TextViewGetCursorVisibleMethodInfo
data TextViewGetDefaultAttributesMethodInfo
data TextViewGetEditableMethodInfo
data TextViewGetHadjustmentMethodInfo
data TextViewGetIndentMethodInfo
data TextViewGetInputHintsMethodInfo
data TextViewGetInputPurposeMethodInfo
data TextViewGetIterAtLocationMethodInfo
data TextViewGetIterAtPositionMethodInfo
data TextViewGetIterLocationMethodInfo
data TextViewGetJustificationMethodInfo
data TextViewGetLeftMarginMethodInfo
data TextViewGetLineAtYMethodInfo
data TextViewGetLineYrangeMethodInfo
data TextViewGetMonospaceMethodInfo
data TextViewGetOverwriteMethodInfo
data TextViewGetPixelsAboveLinesMethodInfo
data TextViewGetPixelsBelowLinesMethodInfo
data TextViewGetPixelsInsideWrapMethodInfo
data TextViewGetRightMarginMethodInfo
data TextViewGetTabsMethodInfo
data TextViewGetTopMarginMethodInfo
data TextViewGetVadjustmentMethodInfo
data TextViewGetVisibleRectMethodInfo
data TextViewGetWindowMethodInfo
data TextViewGetWindowTypeMethodInfo
data TextViewGetWrapModeMethodInfo
data TextViewImContextFilterKeypressMethodInfo
data TextViewMoveChildMethodInfo
data TextViewMoveMarkOnscreenMethodInfo
data TextViewMoveVisuallyMethodInfo
data TextViewPlaceCursorOnscreenMethodInfo
data TextViewResetImContextMethodInfo
data TextViewScrollMarkOnscreenMethodInfo
data TextViewScrollToIterMethodInfo
data TextViewScrollToMarkMethodInfo
data TextViewSetAcceptsTabMethodInfo
data TextViewSetBorderWindowSizeMethodInfo
data TextViewSetBottomMarginMethodInfo
data TextViewSetBufferMethodInfo
data TextViewSetCursorVisibleMethodInfo
data TextViewSetEditableMethodInfo
data TextViewSetIndentMethodInfo
data TextViewSetInputHintsMethodInfo
data TextViewSetInputPurposeMethodInfo
data TextViewSetJustificationMethodInfo
data TextViewSetLeftMarginMethodInfo
data TextViewSetMonospaceMethodInfo
data TextViewSetOverwriteMethodInfo
data TextViewSetPixelsAboveLinesMethodInfo
data TextViewSetPixelsBelowLinesMethodInfo
data TextViewSetPixelsInsideWrapMethodInfo
data TextViewSetRightMarginMethodInfo
data TextViewSetTabsMethodInfo
data TextViewSetTopMarginMethodInfo
data TextViewSetWrapModeMethodInfo
data TextViewStartsDisplayLineMethodInfo
data TextViewWindowToBufferCoordsMethodInfo
